]> pd.if.org Git - zpackage/blobdiff - zpm-install
add -s option to stat to print file size
[zpackage] / zpm-install
index cf0df5f2e89f49ca567188cb27df629ef9728ada..64b064bf7170d90e4b85f9e12b53374f41a82946 100755 (executable)
@@ -1,7 +1,12 @@
 #!/bin/sh
 
+warn() {
+       echo $* 1>&2
+}
+
 die() {
        echo $* 1>&2
+       zpm log -i -a 'aborting install' -t "$pkgid" "$*"
        exit 1
 }
 
@@ -9,16 +14,20 @@ dryrun=0
 verbose=0
 runscripts=1
 runconfigure=1
-localdb=/var/lib/zpm/local.db
+absorb=0
+overwrite=0
+syncopts=''
 
 # zpm-install [-SCn] [ -d localdb ] [ -f pkgfile ] [ -R installroot ] pkgstr ...
-while getopts f:d:R:nSCv opt; do
+while getopts f:d:R:nSCvAO opt; do
        case $opt in
                f) pkgfile="$OPTARG" ;;
                d) localdb="$OPTARG" ;;
                R) rootdir="$OPTARG" ;;
                S) runscripts=0 ;;
                C) runconfigure=0 ;;
+               A) absorb=1; syncopts="${syncopts} -A" ;;
+               O) overwrite=1; syncopts="${syncopts} -O" ;;
                n) dryrun=1 ;;
                v) verbose=1 ;;
                *) die "usage ..." ;;
@@ -38,38 +47,38 @@ if [ -z "$pkgfile" ]; then
        pkgfile=$ZPM_PACKAGE_FILE
 fi
 
-# cases C = create ok, R = full package id, F = specified package file
+# cases R = full package id, F = specified package file
 
 # immediate error
-# C-- 100 error, must specify something
-# --- 000 error, must specify something
+# -- 00 error, must specify something
 if [ -z "$release" ] && [ -z "$pkgfile" ]; then
        die must specify package file or complete package id
 fi
 
 # TODO look in package file
-# --F 001 error, wouldn't know which pkgid to create, could derive from file?
-# C-F 101 error, since package wouldn't exist in file to find
+# -F 01 error, wouldn't know which pkgid to create, could derive from file?
 if [ -z "$release" ]; then
-       die must specify complete package id
+       # must have package file, or would have died above
+       pkgid=$(zpm findpkg -f $pkgfile $pkgid)
+       if [ -n "$pkgid" ]; then
+               eval "$(zpm parse -E $pkgid)"
+       fi
+fi
+
+if [ -z "$pkgid" ]; then
+       die "$0 can't figure out a package id"
 fi
 
 # set file from pkgid
-# CR- 110 set file from pkgid, create if needed
-# -R- 010 set file from pkgid, create in file, error if no file
+# R- 10 set file from pkgid, create in file, error if no file
 if [ -z "$pkgfile" ]; then
        pkgfile="$pkgid.zpm"
 fi
 
 # will now be one of these
-# CRF 111 create package in file given, create file if needed
-# -RF 011 create package in file, error if file doesn't exist
+# RF 11 create package in file, error if file doesn't exist
 if [ ! -f "$pkgfile" ]; then
-       if [ $create -eq 1 ]; then
-               zpm init $pkgfile
-       else
-               die $pkgfile does not exist
-       fi
+       die $pkgfile does not exist
 fi
 
 if [ "$idempotent" = 1 ]; then
@@ -80,6 +89,27 @@ package=$(zpm quote "$name")
 pkgver=$(zpm quote "$version")
 pkgrel=$(zpm quote "$release")
 
+if [ -n "$rootdir" ]; then
+       : rootdir=${rootdir%%/}
+fi
+
+if [ -z "$localdb" ]; then
+       localdb=${rootdir}/var/lib/zpm/local.db
+fi
+
+if [ ! -f "$localdb" ]; then
+       if [ -n "$rootdir" ] && [ ! -d $rootdir ]; then
+               mkdir $rootdir || die "can't create $rootdir: $!"
+       fi
+       for d in /var /var/lib /var/lib/zpm; do
+               test -d $rootdir/$d || mkdir $rootdir/$d || die "can't create $rootdir/$d/: $!"
+       done
+       zpm init "$localdb"
+       if [ $? -ne 0 ]; then
+               die "aborting install"
+       fi
+fi
+
 ZPMDB=$localdb
 export ZPMDB
 
@@ -98,17 +128,26 @@ if [ $var -gt 0 ]; then
        zpm list -v -f $localdb -s installing 
        die "already ($localdb) installing $var package(s)"
 fi
+# check if we're installing something already
+var=$(zpm list -f $localdb -s removing | wc -l)
+if [ $var -gt 0 ]; then
+       zpm list -v -f $localdb -s removing 
+       die "already ($localdb) removing $var package(s)"
+fi
+var=$(zpm list -f $localdb -s updating | wc -l)
+if [ $var -gt 0 ]; then
+       zpm list -v -f $localdb -s updating 
+       die "already ($localdb) updating $var package(s)"
+fi
 
 if [ -n "$rootdir" ]; then
        ZPM_ROOT_DIR="$rootdir"
        export ZPM_ROOT_DIR
 fi
 
-# TODO mark already installed packages as updating?
 for pkgstr in "$@"; do
-       pkgid=$(zpm findpkg $pkgfile $pkgstr)
+       pkgid=$(zpm findpkg -f $pkgfile $pkgstr)
        if [ $? -ne 0 ]; then
-               # TODO log
                die "can't find package $pkgstr in $pkgfile"
        fi
 
@@ -123,39 +162,54 @@ for pkgstr in "$@"; do
        current=$(zpm list -s installed "$package")
        
        if [ $runscripts -gt 0 ]; then
-               zpm runscript -f $pkgfile -p pre-install $pkgid $current
+               # TODO run pre-upgrade script if needed
+               # zpm runscript -p pre-upgrade $current $pkgid
+               zpm script -f $pkgfile -p pre-install $pkgid $current
                if [ $? -ne 0 ]; then
-                       # TODO log
                        die "pre-install script for $pkgid failed"
                fi
        fi
 
+       # remove the package if it exists.  can't be in an installed
+       # state, would have bailed above.  So, if it exists, can only
+       # be 'upgraded'.  This should be fast, because we won't run
+       # a garbage collect, so any possible duplicate files between
+       # an upgraded or removed files, if they're there, won't need
+       # to be merged.
+
        # only merge if localdb and pkgfile are different
        if [ "$pkgfile" != "$ZPMDB" ]; then
+               zpm rmpackage $pkgid
                zpm merge -f $pkgfile -s installing $pkgid
                if [ $? -ne 0 ]; then
-                       # TODO log
                        die "merging $pkgid failed"
                fi
+       else
+               zpm pkg $pkgid status=installing
        fi
 
        #zpm shell $ZPMDB 'select * from install_status' 1>&2
        if [ $dryrun -gt 0 ]; then
                #zpm list -v
                #zpm shell $ZPMDB 'select * from install_status'
-               zpm pkgfiles -nv -f $pkgfile $pkgid
+               zpm syncfs $syncopts -nv -f $pkgfile
                zpm pkg $pkgid status=dryrun
                continue
        fi
 
-       zpm pkgfiles -f $pkgfile $pkgid
+       if [ $verbose -gt 0 ]; then
+               syncopts="${syncopts} -v"
+       fi
+
+       zpm syncfs $syncopts -f $pkgfile
 
        if [ $? -ne 0 ]; then
-               die 'zpm-pkgfiles failed';
+               zpm pkg $pkgid status=failed
+               die 'zpm-syncfs failed';
        fi
 
        if [ $runscripts -gt 0 ]; then
-               zpm runscript -f $pkgfile -p post-install $pkgid $current
+               zpm script -f $pkgfile -p post-install $pkgid $current
        fi
 
        if [ -n "$current" ]; then
@@ -164,9 +218,23 @@ for pkgstr in "$@"; do
                zpm pkg $pkgid status=installed
        fi
 
+       if [ $(id -u) -eq 0 ]; then
+               if [ ! -d $rootdir/etc ]; then
+                       warn "no etc directory in $rootdir, skipping ldconfig"
+               elif [ -f $rootdir/sbin/ldconfig ]; then
+                       $rootdir/sbin/ldconfig -r ${rootdir:-/}
+               elif [ -f /sbin/ldconfig ]; then
+                       /sbin/ldconfig -r ${rootdir:-/}
+               else
+                       true
+               fi
+       fi
+
        # TODO skip configure if not on a terminal, regardless of settings
        # TODO will need force option
        if [ $runconfigure -gt 0 ]; then
-               zpm runscript -f $pkgfile -p configure $pkgid $current
+               zpm script -f $pkgfile -p configure $pkgid $current
+       else
+               true
        fi
 done